require 'generators/godmode/orm_helpers'

module Godmode
  module Generators
    class CategoryGenerator < Rails::Generators::Base
      include Godmode::Generators::OrmHelpers
      include Rails::Generators::Migration

      source_root File.expand_path('../templates', __FILE__)
      desc "Insert category model using awesome_nested_set."

      desc "create category model using awesome_nested_set"
      class_option "tree_gem", :type => :string, :default => 'awesome_nested_set'

      desc "create admin interface using rails_admin"
      class_option "admin", :type => :boolean, :default => true

      def generate_templates
        gem options.tree_gem
        template "category/#{options.tree_gem}/model.rb", "app/models/category.rb"
        migration "category/awesome_nested_set/migration.rb", "create_awesome_nested_set_category" 
        if options.admin
          template "category/#{options.tree_gem}/rails_admin.rb", "config/initializers/rails_admin_#{options.tree_gem}.rb"
          template "category/#{options.tree_gem}/admin_config.rb", "app/models/admin_config/category.rb"
          if options.tree_gem == 'ancestry'
            gem 'rails_admin_nestable' 
          elsif options.tree_gem == 'awesome_nested_set'
            gem 'rails_admin_nested_set'
          end
        end
      end

      def self.next_migration_number(path)
        @migration_number = Time.now.utc.strftime("%Y%m%d%H%M%S").to_i.to_s
      end

    end
  end
end