require 'generators/godmode/orm_helpers'

module Godmode
  module Generators
    class CategoryGenerator < Rails::Generators::Base
      include Godmode::Generators::OrmHelpers
      include Rails::Generators::Migration

      source_root File.expand_path('../templates', __FILE__)
      desc "Insert gallery_image model using carrierwave and fog."

      def generate_templates
        gem 'carrierwave'
        gem 'fog'
        gem 'rmagick'
        generate "godmode:scaffold", "gallery_image"
      end

      def self.next_migration_number(path)
        @migration_number = Time.now.utc.strftime("%Y%m%d%H%M%S").to_i.to_s
      end

    end
  end
end