module Godmode
  module Generators

    class ScaffoldGenerator < Rails::Generators::Base
      source_root File.expand_path('../templates', __FILE__)
      argument :name, type: :string

      desc "Include rails_admin file."
      class_option "admin", :type => :boolean, :default => true

      def generate_templates
        template "scaffold/model.rb", "app/models/#{file_name}.rb"
        if options.admin
          template "scaffold/admin_config.rb", "app/models/admin_config/#{file_name}.rb"
        end
        template "scaffold/controller.rb", "app/controllers/#{file_name.pluralize}_controller.rb"
      end

    private

      def file_name
        name.singularize.underscore
      end

      def class_name
        name.singularize.camelize
      end
    end

  end
end