class ImageUploader < CarrierWave::Uploader::Base
  include CarrierWave::RMagick
  include Sprockets::Rails::Helper

  storage :fog

  version :thumb do
    process :resize_to_fit => [100, 100]
  end

  def store_dir
    "uploads/#{class_name(model).to_s.underscore}/#{mounted_as}/#{model.id}"
  end

  def class_name model
    model.class.superclass.name == "ActiveRecord::Base" ? model.class : model.class.superclass
  end

end
